Index: palm/trunk/SOURCE/biometeorology_mod.f90
===================================================================
--- palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3445)
+++ palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3448)
@@ -168,187 +554,40 @@
     USE kinds
 
-    IMPLICIT NONE
-
-    CHARACTER (LEN=*) ::  mode    !< 
-    CHARACTER (LEN=*) :: variable !< 
-
-    INTEGER(iwp) ::  i !< 
-    INTEGER(iwp) ::  j !< 
-    INTEGER(iwp) ::  k !< 
-    INTEGER(iwp) ::  l, m !< index of current surface element
-
-    REAL(wp)     ::  mrt, pet
-
-    IF ( mode == 'allocate' )  THEN
-
-       SELECT CASE ( TRIM( variable ) )
-             CASE ( 'bio_mrt' )
-                IF ( .NOT. ALLOCATED( bio_mrt_av ) )  THEN
-                   ALLOCATE( bio_mrt_av(nmrtbl) )
-                ENDIF
-                bio_mrt_av = 0.0_wp
-
-             CASE ( 'bio_pet' )
-                IF ( .NOT. ALLOCATED( bio_pet_av ) )  THEN
-                   ALLOCATE( bio_pet_av(nmrtbl) )
-                ENDIF
-                bio_pet_av = 0.0_wp
-
-          CASE DEFAULT
-             CONTINUE
-
-       END SELECT
-
-    ELSEIF ( mode == 'sum' )  THEN
-
-       SELECT CASE ( TRIM( variable ) )
-
-          CASE ( 'bio_mrt' )
-             IF ( ALLOCATED( bio_mrt_av ) )  THEN
-
-                 IF ( nmrtbl > 0 )  THEN
-                    IF ( mrt_include_sw )  THEN
-                       bio_mrt_av(:) = bio_mrt_av(:) + ((human_absorb*mrtinsw(:) &
-                           + human_emiss*mrtinlw(:)) / (human_emiss*sigma_sb)) ** .25_wp
-                    ELSE
-                       bio_mrt_av(:) = bio_mrt_av(:) + &
-                                       (human_emiss * mrtinlw(:) / sigma_sb) ** .25_wp
-                    ENDIF
-                 ENDIF
-             ENDIF
-
-          CASE ( 'bio_pet' )
-             IF ( ALLOCATED( bio_pet_av ) )  THEN
-                DO  l = 1, nmrtbl
-                   i = mrtbl(ix,l)
-                   j = mrtbl(iy,l)
-                   k = mrtbl(iz,l)
-
-                   IF ( mrt_include_sw )  THEN
-                      mrt = ((human_absorb*mrtinsw(l) + human_emiss*mrtinlw(l)) &
-                             / (human_emiss*sigma_sb)) ** .25_wp
-                   ELSE
-                      mrt = mrt + (human_emiss * mrtinlw(l) / sigma_sb) ** .25_wp
-                   ENDIF
-
-                   CALL calculate_pet_static(                                      &
-                           pt(k,j,i) * (hyp(k) / 100000.0_wp )**0.286_wp + t_zero, &  !< Air temperature (Â°C)
-                           q(k,j,i) * hyp(k) / ( q(k,j,i) + rd_d_rv ) / 100._wp,   &  !< Vapor pressure (hPa)
-                           SQRT( MAX( ( ( u(k,j,i) + u(k,j,i+1) ) * 0.5_wp )**2 +  &
-                                      ( ( v(k,j,i) + v(k,j+1,i) ) * 0.5_wp )**2 +  &
-                                      ( ( w(k,j,i) + w(k-1,j,i) ) * 0.5_wp )**2,   &
-                                      0.01_wp ) ),                                 &  !< Wind speed (at scalar gridpoint) (m/s)
-                           mrt + t_zero,                                           &  !< Mean radiant temperature (Â°C)
-                           (hyp(k) + p(k,j,i)) * 0.01_wp,                          &  !< Air pressure (hPa)
-                           pet )                                                      !< output variable of PET
-
-                    bio_pet_av(l) = bio_pet_av(l) + pet
-                ENDDO
-             ENDIF
-
-          CASE DEFAULT
-             CONTINUE
-
-       END SELECT
-
-    ELSEIF ( mode == 'average' )  THEN
-
-       SELECT CASE ( TRIM( variable ) )
-
-          CASE ( 'bio_mrt' )
-             IF ( ALLOCATED( bio_mrt_av ) )  THEN
-                bio_mrt_av(:) = bio_mrt_av(:) / REAL( average_count_3d, KIND=wp )
-             ENDIF
-
-          CASE ( 'bio_pet' )
-             IF ( ALLOCATED( bio_pet_av ) )  THEN
-                bio_pet_av(:) = bio_pet_av(:) / REAL( average_count_3d, KIND=wp )
-             ENDIF
-
-       END SELECT
-
-    ENDIF
-
-END SUBROUTINE biometeorology_3d_data_averaging
-
-
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine defining appropriate grid for netcdf variables.
-!> It is called out from subroutine netcdf.
-!------------------------------------------------------------------------------!
- SUBROUTINE biometeorology_define_netcdf_grid( var, found, grid_x, grid_y, grid_z )
-
-    IMPLICIT NONE
-
-    CHARACTER (LEN=*), INTENT(IN)  ::  var         !< 
-    LOGICAL, INTENT(OUT)           ::  found       !< 
-    CHARACTER (LEN=*), INTENT(OUT) ::  grid_x      !< 
-    CHARACTER (LEN=*), INTENT(OUT) ::  grid_y      !< 
-    CHARACTER (LEN=*), INTENT(OUT) ::  grid_z      !< 
-
-    found  = .TRUE.
-
-
-!
-!-- Check for the grid
-    SELECT CASE ( TRIM( var ) )
-
-       CASE ( 'bio_mrt', 'bio_pet' )
-          grid_x = 'x'
-          grid_y = 'y'
-          grid_z = 'zu'
-
-       CASE DEFAULT
-          found  = .FALSE.
-          grid_x = 'none'
-          grid_y = 'none'
-          grid_z = 'none'
-
-        END SELECT
-
- END SUBROUTINE biometeorology_define_netcdf_grid
-
-
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine defining 3D output variables
-!------------------------------------------------------------------------------!
- SUBROUTINE biometeorology_data_output_3d( av, variable, found, local_pf, nzb_do, nzt_do )
- 
-
-    USE indices
-
-    USE kinds
-
-
-    IMPLICIT NONE
-
-    CHARACTER (LEN=*) ::  variable !< 
-
-    INTEGER(iwp) ::  av          !<
-    INTEGER(iwp) ::  i, j, k, l  !<
-    INTEGER(iwp) ::  nzb_do      !<
-    INTEGER(iwp) ::  nzt_do      !<
-
-    LOGICAL      ::  found       !<
-
-    REAL(wp)     ::  fill_value = -999.0_wp    !< value for the _FillValue attribute
-
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf !<
-    
-    REAL(wp)     ::  mrt, pet
+
+    IMPLICIT NONE
+
+!-- Input variables
+    CHARACTER (LEN=*), INTENT(IN) ::  variable   !< Char identifier to select var for output
+    INTEGER(iwp), INTENT(IN) ::  av       !< Use averaged data? 0 = no, 1 = yes?
+    INTEGER(iwp), INTENT(IN) ::  nzb_do   !< Unused. 2D. nz bottom to nz top
+    INTEGER(iwp), INTENT(IN) ::  nzt_do   !< Unused.
+
+!-- Output variables
+    LOGICAL, INTENT(OUT) ::  found   !< Output found?
+    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf   !< Temp. result grid to return
+
+!-- Internal variables
+    INTEGER(iwp) ::  l    !< Running index, radiation grid
+    INTEGER(iwp) ::  i    !< Running index, x-dir
+    INTEGER(iwp) ::  j    !< Running index, y-dir
+    INTEGER(iwp) ::  k    !< Running index, z-dir
+
+    CHARACTER (LEN=:), allocatable ::  variable_short  !< Trimmed version of char variable
+
+    REAL(wp), PARAMETER ::  fill_value = -999._wp
+    REAL(wp) ::  mrt  !< Buffer for mean radiant temperature
 
     found = .TRUE.
-
-
-    SELECT CASE ( TRIM( variable ) )
-
-
-        CASE ( 'bio_mrt' )
+    variable_short = TRIM( variable )
+
+    IF ( variable_short(1:4) /= 'biom' ) THEN
+!--   Nothing to do, set found to FALSE and return immediatelly
+      found = .FALSE.
+      RETURN
+    ENDIF
+
+    SELECT CASE ( variable_short )
+
+        CASE ( 'biom_mrt' )
 
             local_pf = REAL( fill_value, KIND = wp )
@@ -366,43 +605,55 @@
             ENDDO
 
-        CASE ( 'bio_pet' )
-            local_pf = REAL( fill_value, KIND = wp )
+        CASE ( 'biom_tmrt' )        ! 2d-array
+              DO  i = nxl, nxr
+                 DO  j = nys, nyn
+                    local_pf(i,j,nzb_do) = REAL( tmrt_grid(j,i), sp )
+                 ENDDO
+              ENDDO
+
+        CASE ( 'biom_pt' )        ! 2d-array
             IF ( av == 0 )  THEN
-                DO  l = 1, nmrtbl
-                    i = mrtbl(ix,l)
-                    j = mrtbl(iy,l)
-                    k = mrtbl(iz,l)
-
-                    IF ( mrt_include_sw )  THEN
-                        mrt = ((human_absorb*mrtinsw(l) + human_emiss*mrtinlw(l)) &
-                               / (human_emiss*sigma_sb)) ** .25_wp
-                    ELSE
-                        mrt = mrt + (human_emiss*mrtinlw(l) / sigma_sb) ** .25_wp
-                    ENDIF
-
-                    CALL calculate_pet_static(                                      &
-                       pt(k,j,i) * (hyp(k) / 100000.0_wp )**0.286_wp + t_zero, &  !< Air temperature (Â°C)
-                       q(k,j,i) * hyp(k) / ( q(k,j,i) + rd_d_rv ) / 100.0_wp,  &  !< Vapor pressure (hPa)
-                       SQRT( MAX( ( ( u(k,j,i) + u(k,j,i+1) ) * 0.5_wp )**2 +  &
-                                  ( ( v(k,j,i) + v(k,j+1,i) ) * 0.5_wp )**2 +  &
-                                  ( ( w(k,j,i) + w(k-1,j,i) ) * 0.5_wp )**2,   &
-                                  0.01_wp ) ),                                 &  !< Wind speed (at scalar gridpoint) (m/s)
-                       mrt + t_zero,                                           &  !< Mean radiant temperature (Â°C)
-                       (hyp(k) + p(k,j,i)) * 0.01_wp,                          &  !< Air pressure (hPa)
-                       pet )                                                      !< output variable of PET
-
-               local_pf(i,j,k) = pet
-
-            ENDDO
-         ELSE
-            IF ( ALLOCATED( bio_pet_av ) ) THEN
-               DO  l = 1, nmrtbl
-                  i = mrtbl(ix,l)
-                  j = mrtbl(iy,l)
-                  k = mrtbl(iz,l)
-                  local_pf(i,j,k) = bio_pet_av(l)
-               ENDDO
-            ENDIF
-         ENDIF
+              DO  i = nxl, nxr
+                 DO  j = nys, nyn
+                    local_pf(i,j,nzb_do) = REAL( pt_grid(j,i), sp )
+                 ENDDO
+              ENDDO
+            ELSE
+              DO  i = nxl, nxr
+                 DO  j = nys, nyn
+                    local_pf(i,j,nzb_do) = REAL( pt_av_grid(j,i), sp )
+                 ENDDO
+              ENDDO
+            END IF
+
+        CASE ( 'biom_utci' )        ! 2d-array
+            IF ( av == 0 )  THEN
+              DO  i = nxl, nxr
+                 DO  j = nys, nyn
+                    local_pf(i,j,nzb_do) = REAL( utci_grid(j,i), sp )
+                 ENDDO
+              ENDDO
+            ELSE
+              DO  i = nxl, nxr
+                 DO  j = nys, nyn
+                    local_pf(i,j,nzb_do) = REAL( utci_av_grid(j,i), sp )
+                 ENDDO
+              ENDDO
+            END IF
+
+        CASE ( 'biom_pet' )        ! 2d-array
+            IF ( av == 0 )  THEN
+              DO  i = nxl, nxr
+                 DO  j = nys, nyn
+                    local_pf(i,j,nzb_do) = REAL( pet_grid(j,i), sp )
+                 ENDDO
+              ENDDO
+            ELSE
+              DO  i = nxl, nxr
+                 DO  j = nys, nyn
+                    local_pf(i,j,nzb_do) = REAL( pet_av_grid(j,i), sp )
+                 ENDDO
+              ENDDO
+            END IF
 
        CASE DEFAULT
